%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%% Program:
%%%    Path definition with right recursion in a 4x4 grid 
%%% Number of answers for the query '?- rpath(X,Z).':
%%%    256
%%% Possible program transformation:
%%%
%%%    rpath(X,Z) :- 
%%%       tabled_call(rpath(X,Z),SgId,rpath_table(SgId,X,Z)).
%%%
%%%    rpath_table(SgId,X,Z) :- 
%%%       edge(X,Z), 
%%%       new_answer(SgId,rpath(X,Z)).
%%%    rpath_table(SgId,X,Z) :- 
%%%       edge(X,Y), 
%%%       rpath(Y,Z), 
%%%       new_answer(SgId,rpath(X,Z)).
%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- table rpath/2.

rpath(X,Z) :- edge(X,Z).
rpath(X,Z) :- edge(X,Y), rpath(Y,Z).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

edge(1,2).
edge(2,1).
edge(2,3).
edge(3,2).
edge(3,4).
edge(4,3).

edge(5,6).
edge(6,5).
edge(6,7).
edge(7,6).
edge(7,8).
edge(8,7).

edge(9,10).
edge(10,9).
edge(10,11).
edge(11,10).
edge(11,12).
edge(12,11).

edge(13,14).
edge(14,13).
edge(14,15).
edge(15,14).
edge(15,16).
edge(16,15).

edge(1,5).
edge(5,1).
edge(5,9).
edge(9,5).
edge(9,13).
edge(13,9).

edge(2,6).
edge(6,2).
edge(6,10).
edge(10,6).
edge(10,14).
edge(14,10).

edge(3,7).
edge(7,3).
edge(7,11).
edge(11,7).
edge(11,15).
edge(15,11).

edge(4,8).
edge(8,4).
edge(8,12).
edge(12,8).
edge(12,16).
edge(16,12).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
